#include <stdio.h>
#include <owl.h>
#include <bwcc.h>
#include <bwindow.h>
#include <listbox.h>

#define LBN_TRANSFER WM_USER + 1

class TLarryApplication : public TApplication
{
public:
	TLarryApplication(LPSTR AParent,
										HINSTANCE hInstance,
										HINSTANCE hPrevInstance,
										LPSTR lpCmdLine,
										int nCMdShow) :
										TApplication (AParent,
																	hInstance, hPrevInstance,
																	lpCmdLine, nCmdShow) {};
	virtual void InitMainWindow();

};


_CLASSDEF(TLarryListBox)
class TLarryListBox : public TListBox
{
public:
	TLarryListBox(PTWindowsObject AParent, int AnID)	:
		TListBox(AParent, AnID) {};

  // Process any keystrokes you need 
	virtual void WMKeyDown(RTMessage Msg) = [WM_FIRST + WM_KEYDOWN]
	{

		switch (Msg.WParam)
		{
    	// Notify parent that return was pressed.
			case VK_RETURN: SendMessage(Parent->HWindow, WM_COMMAND, GetId(), MAKELONG(HWindow, LBN_TRANSFER));  
											break;
			
      // You have to handle movement to the next or previous control now.
			case VK_TAB:
				if (GetKeyState(VK_SHIFT))
					SetFocus(GetNextDlgTabItem(Parent->HWindow, HWindow, TRUE));
				else
					SetFocus(GetNextDlgTabItem(Parent->HWindow, HWindow, FALSE));
				break;

			// other keystrokes handled normally.				
			default : DefWndProc(Msg);
    }
	}

  // Tell dialog that this listbox will process keystrokes
	virtual void WMGetDlgCode(RTMessage Msg) = [WM_FIRST + WM_GETDLGCODE]
	{
		Msg.Result = DLGC_WANTALLKEYS;
	}
};



_CLASSDEF(TLarryDlg)
class TLarryDlg : public TDialog
{
public:
	PTLarryListBox LarryBox1;
	PTLarryListBox LarryBox2;

	TLarryDlg(PTWindowsObject AParent, LPSTR AName, PTModule ATModule = NULL) :
		TDialog(AParent, AName, ATModule)
	{
		LarryBox1 = new TLarryListBox(this, 101);
		LarryBox2 = new TLarryListBox(this, 102);
	}


	virtual void HandleTransfer(RTMessage Msg) = [ID_FIRST + 101]
	{
		char temp[80];

		switch (Msg.LP.Hi)
		{
			case LBN_TRANSFER:
				{
					if (LarryBox1->GetSelIndex() >= 0)
          {
	        	LarryBox1->GetString(temp, LarryBox1->GetSelIndex());
						LarryBox2->AddString(strdup(temp));
          }
        }
			default : DefWndProc(Msg);
    }
	}


	virtual void SetupWindow()
	{
  	TDialog::SetupWindow();
		LarryBox1->AddString("This is a test");
		LarryBox1->AddString("This is another test");
	}
};





void TLarryApplication::InitMainWindow()
{
	//nCmdShow = SW_SHOWMAXIMIZED;
	MainWindow = new TLarryDlg(NULL, "Larry");
  // HAccTable = LoadAccelerators(hInstance, "GroupAcc");
}



int PASCAL WinMain (HINSTANCE hInstance,
										HINSTANCE hPrevInstance,
										LPSTR lpCmdLine,
										int nCmdShow)

{
	TLarryApplication LarryAppl("MLH Custom", hInstance,
														hPrevInstance, lpCmdLine, nCmdShow);
	LarryAppl.Run();
	return LarryAppl.Status;
}